// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from leo_msgs:msg/WheelOdom.idl
// generated code does not contain a copyright notice

#include "leo_msgs/msg/detail/wheel_odom__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_leo_msgs
const rosidl_type_hash_t *
leo_msgs__msg__WheelOdom__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x0f, 0x80, 0x31, 0x16, 0xb3, 0xab, 0xc6, 0x0b,
      0x72, 0x97, 0xed, 0x52, 0x11, 0x4e, 0x6a, 0x40,
      0x67, 0xb9, 0xe4, 0xc4, 0xd5, 0xf3, 0x97, 0x32,
      0xcc, 0xf0, 0x39, 0x54, 0x00, 0x9f, 0xe0, 0xab,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types
#include "builtin_interfaces/msg/detail/time__functions.h"

// Hashes for external referenced types
#ifndef NDEBUG
static const rosidl_type_hash_t builtin_interfaces__msg__Time__EXPECTED_HASH = {1, {
    0xb1, 0x06, 0x23, 0x5e, 0x25, 0xa4, 0xc5, 0xed,
    0x35, 0x09, 0x8a, 0xa0, 0xa6, 0x1a, 0x3e, 0xe9,
    0xc9, 0xb1, 0x8d, 0x19, 0x7f, 0x39, 0x8b, 0x0e,
    0x42, 0x06, 0xce, 0xa9, 0xac, 0xf9, 0xc1, 0x97,
  }};
#endif

static char leo_msgs__msg__WheelOdom__TYPE_NAME[] = "leo_msgs/msg/WheelOdom";
static char builtin_interfaces__msg__Time__TYPE_NAME[] = "builtin_interfaces/msg/Time";

// Define type names, field names, and default values
static char leo_msgs__msg__WheelOdom__FIELD_NAME__stamp[] = "stamp";
static char leo_msgs__msg__WheelOdom__FIELD_NAME__velocity_lin[] = "velocity_lin";
static char leo_msgs__msg__WheelOdom__FIELD_NAME__velocity_ang[] = "velocity_ang";
static char leo_msgs__msg__WheelOdom__FIELD_NAME__pose_x[] = "pose_x";
static char leo_msgs__msg__WheelOdom__FIELD_NAME__pose_y[] = "pose_y";
static char leo_msgs__msg__WheelOdom__FIELD_NAME__pose_yaw[] = "pose_yaw";

static rosidl_runtime_c__type_description__Field leo_msgs__msg__WheelOdom__FIELDS[] = {
  {
    {leo_msgs__msg__WheelOdom__FIELD_NAME__stamp, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE,
      0,
      0,
      {builtin_interfaces__msg__Time__TYPE_NAME, 27, 27},
    },
    {NULL, 0, 0},
  },
  {
    {leo_msgs__msg__WheelOdom__FIELD_NAME__velocity_lin, 12, 12},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {leo_msgs__msg__WheelOdom__FIELD_NAME__velocity_ang, 12, 12},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {leo_msgs__msg__WheelOdom__FIELD_NAME__pose_x, 6, 6},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {leo_msgs__msg__WheelOdom__FIELD_NAME__pose_y, 6, 6},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {leo_msgs__msg__WheelOdom__FIELD_NAME__pose_yaw, 8, 8},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

static rosidl_runtime_c__type_description__IndividualTypeDescription leo_msgs__msg__WheelOdom__REFERENCED_TYPE_DESCRIPTIONS[] = {
  {
    {builtin_interfaces__msg__Time__TYPE_NAME, 27, 27},
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
leo_msgs__msg__WheelOdom__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {leo_msgs__msg__WheelOdom__TYPE_NAME, 22, 22},
      {leo_msgs__msg__WheelOdom__FIELDS, 6, 6},
    },
    {leo_msgs__msg__WheelOdom__REFERENCED_TYPE_DESCRIPTIONS, 1, 1},
  };
  if (!constructed) {
    assert(0 == memcmp(&builtin_interfaces__msg__Time__EXPECTED_HASH, builtin_interfaces__msg__Time__get_type_hash(NULL), sizeof(rosidl_type_hash_t)));
    description.referenced_type_descriptions.data[0].fields = builtin_interfaces__msg__Time__get_type_description(NULL)->type_description.fields;
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# This message represents the pose and velocity of a differential wheeled robot, estimated from the wheel encoders.\n"
  "#\n"
  "# The velocity_* fields represent the linear and angular velocity of the robot.\n"
  "# The pose_* fields represent the x, y and yaw pose of the robot w.r.t. the starting pose.\n"
  "#\n"
  "# The coordinate frame that represents the robot is located at the center of rotation.\n"
  "\n"
  "builtin_interfaces/Time stamp\n"
  "float32 velocity_lin\n"
  "float32 velocity_ang\n"
  "float32 pose_x\n"
  "float32 pose_y\n"
  "float32 pose_yaw";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
leo_msgs__msg__WheelOdom__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {leo_msgs__msg__WheelOdom__TYPE_NAME, 22, 22},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 498, 498},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
leo_msgs__msg__WheelOdom__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[2];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 2, 2};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *leo_msgs__msg__WheelOdom__get_individual_type_description_source(NULL),
    sources[1] = *builtin_interfaces__msg__Time__get_individual_type_description_source(NULL);
    constructed = true;
  }
  return &source_sequence;
}
